/*--------------------------------------------------------------------
 * $Id: mie.h,v 1.3 2001/06/20 14:30:58 pa2h Exp $
 * 
 * This file is part of libRadtran.
 * Copyright (c) 1997-2001 by Arve Kylling and Bernhard Mayer.
 * 
 * ######### Contact info: http://www.libradtran.org #########
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License   
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.        
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of  
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the   
 * GNU General Public License for more details.                    
 * 
 * You should have received a copy of the GNU General Public License          
 * along with this program; if not, write to the Free Software                
 * Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA.
 *--------------------------------------------------------------------*/

#ifndef __mie_h
#define __mie_h

#include "../src_c/miecalc.h"


/* INPUT STRUCTURE */

typedef struct {
  int medium;
  mie_complex crefin;    /* User-defined refractive index */
  double r_mean;
  char *sd_filename;
  char *ri_filename;
  int  program;
  mie_inp_struct   mie;
  mie_wl_inp_struct    wl;
} input_struct;



/* OUTPUT STRUCTURE */

typedef struct {
  int         phi;
} print_struct;


typedef struct {
  mie_out_struct   mie;
  mie_wl_out_struct    wl;
  print_struct    print;
} output_struct;


#endif
