c=======================================================================
c SBDART gaseous absorption module
c
c BM adopted code from SBDART version 1.21
c=======================================================================

      SUBROUTINE SBTAUGAS(nz,z,p,t,wh,wo,sc,wl,sza,
     $     xn2, xo2, xco2, xch4, xn2o, xno2, 
     $     dtau, wght, npass)

c      IMPLICIT NONE

      real total

      INCLUDE 'sbtaugas.inc'

      integer nk
      parameter (nk=3)

      integer iz, nz
      integer k, kd, npass

      real z(mxly), p(mxly), t(mxly), wh(mxly), wo(mxly)
      real uu(mxq,mxly)

      real sc(mxly)

      real dtau(mxly,nk), wght(nk)

      real test, sum
      
      real sza, amu0, wt

      real wl

      real dtcs(mxly), dtls(mxly)
      real dtcv(mxly), dtlv(mxly)

      real tauk(mxly,nk), dtauk(mxly,nk), wtk(mxly,nk),
     &          work(mxly,nk), dtaug(mxly)


      real airmass(mxly), gasabs(nta,mxly)

      integer kdist
      data kdist/3/

      real*8 zip
      parameter (zip=-1.D0)         

      data    xco,  xso2,  xnh3,   xno,  xhno3
     &     /  zip,   zip,   zip,   zip,  zip/


      amu0=cos(sza*3.1415926/180.0)

c      write (*,*) 'xo2  = ', xo2
c      write (*,*) 'xco2 = ', xco2
c      write (*,*) 'xno2 = ', xno2
c      write (*,*) 'xch4 = ', xch4
c      write (*,*) 'xn2o = ', xn2o


      call modmix(xn2,xo2,xco2,xch4,xn2o,xco,xno2,xso2,xnh3,xno,xhno3)
      call absint(uu,nz,z,p,t,wh,wo,0)
      
      
c  gas absorption
      call taugas(wl,uu,amu0,nz,z,dtcs,dtls,0)
      call taugas(wl,uu,1.,nz,z,dtcv,dtlv,0)
      call absgas(airmass,gasabs)
      
c  calculate k distribution
      if(total(dtlv,1,nz).lt..01) then
         kd=0
         npass=1
      else
         call kdistr(nz,mxly,mxq,uu,dtauk,tauk,wtk,work)
         
         test=max(tauk(nz,1),tauk(nz,2),tauk(nz,3))
         if(test.lt.0.01) then
            npass=1
         else
            npass=nk
         endif            
      endif
      
c  loop through k-distribution terms
      
      sum=0
      
      do k=1,npass
         
         call depthscl(kdist,nz,k,npass,wl,amu0,sc,
     &        dtls,dtcs,dtcv,dtlv,dtauk,wtk,
     &        dtaug,wt)
         
         
c  copy data to final destination         
         do iz=1,nz
            dtau(iz,k) = dtaug(iz)
         enddo

         wght(k) = wt

c         sum = sum + wt*exp(-total(dtaug,2,nz))
      enddo

c      write (*,*) wl, sum, sum1

      RETURN
      END
c=======================================================================
c purpose: returns the sum of zz(i), for i=i1,i2

      function total(zz,i1,i2)
      dimension zz(*)
      total=0.
      do 10 i=i1,i2
        total=total+zz(i)
 10   continue
      return
      end
c=======================================================================
